#include<cstdio>
#include<iostream>
#define ll long long
using namespace std;
ll mod=998244353,rez,cnt,c;
int a[10000010],b[100010],n,m;
int main(){

//        freopen("test.txt","r",stdin);


    scanf("%d %d",&n,&m);

    for(int i=1;i<=m;i++){
        scanf("%d",&b[i]);
    }

    cin>>c;

   for(int i=1;i<=n;i++)a[i]=i;

    for(int i=0;i<=n-m;i++){
        for(int j=1;j<=m;j++)
            a[i+b[j]]=a[i+j];
    }
    cnt=1;
    for(int i=1;i<=n;i++){
       cnt=(cnt*c)%mod;
       rez=((((ll)(cnt*(ll)a[i]))%mod)+rez)%mod;
    }
    printf("%lld\n",rez);

return 0;
}